Attribute VB_Name = "Module3"
Public FDOCTYPE As String, FPARTCODE As String, FQUANTITY As String, FMATERIAL As String, FSPECIFICATIONS2 As String, FPARTTYPE As String, FPOSOLD As String, FFILENAME As String, FPARTNAME As String, FSCALE As String, FFILENAME2 As String, FPARTNAME2 As String

Public FPOS As String, FNOTES As String

Public FPROJECT As String, FCREATED As String, FAPPROVED As String, FVERSION As String, FCRDATE As String, FDEVELOPED As String, FREDESIGNED As String, FSUPPORTED As String, FLICENCE As String

Public PC As String, PC2 As Integer

Public FSHEETg As String, umat As VbMsgBoxStyle, FTBD As String

Public NAME_ES As String, NAME_DE As String

Public SPL As VbMsgBoxStyle, XLFS As Collection


Sub FIELDS(Optional oSheet As Sheet)
    'Before running this code, add reference to Microsoft XML 6.0 in this VBA project
    Dim oDrawDoc As DrawingDocument
    Set oDrawDoc = ThisApplication.ActiveDocument
'    Dim oSheet As Sheet
    Dim oView As DrawingView
    Dim tb As TitleBlock
    Dim textB As TextBox
    Dim xml As DOMDocument
    Dim node As IXMLDOMNode
    
    Dim FSHEET As String

    If oSheet Is Nothing Then
    Set oSheet = oDrawDoc.ActiveSheet
    End If
    
    
    FSHEET = NSH(oSheet.Name) 'Mid(oSheet.Name, InStr(1, oSheet.Name, ":") + 1)
    Debug.Print "SHEET:" + FSHEET
    
    Set tb = oSheet.TitleBlock
    
'    For I = 1 To tb.Definition.Sketch.TextBoxes.Count
'    TTT = Str$(I) + " : " + tb.Definition.Sketch.TextBoxes(I).FormattedText
'    Debug.Print TTT
'    Next I

    Set textB = tb.Definition.Sketch.TextBoxes(28)
    FFILENAME = tb.GetResultText(textB)
    Debug.Print "FILENAME:" + FFILENAME
    
    If oSheet.DrawingViews.Count = 0 Then
        GoTo NOVIEW3
    End If
    
    Set oView = oSheet.DrawingViews(1)
    FFILENAME2 = oView.ReferencedDocumentDescriptor.DisplayName
    If FFILENAME <> FFILENAME2 Then
'        FFILENAME = IIf(FFILENAME = "", "", FFILENAME + " OR ") + FFILENAME2
    End If
NOVIEW3:

'    tb.SetPromptResultText textB, InputBox("FILE NAME", , FFILENAME)
    
    
    Set textB = tb.Definition.Sketch.TextBoxes(27)
    FPARTNAME = tb.GetResultText(textB)
    Debug.Print "PARTNAME:" + FPARTNAME
    
    If oSheet.DrawingViews.Count = 0 Then
        GoTo NOVIEW4
    End If
    
    Set oView = oSheet.DrawingViews(1)
    
    If oView.ReferencedDocumentDescriptor.ReferencedDocument Is Nothing Then
    FPARTNAME2 = FFILENAME2
    Else
    FPARTNAME2 = oView.ReferencedDocumentDescriptor.ReferencedDocument.PropertySets.Item(3).Item(2).Value
    End If
    If FPARTNAME <> FPARTNAME2 Then
'        FPARTNAME = IIf(FPARTNAME = "", "", FPARTNAME + " OR ") + FPARTNAME2
    End If
    
NOVIEW4:

'    tb.SetPromptResultText textB, InputBox("PART NAME", , FPARTNAME)
    

    Set textB = tb.Definition.Sketch.TextBoxes(10)
    FDOCTYPE = tb.GetResultText(textB)
    Debug.Print "DOCTYPE:" + FDOCTYPE
    
    If oSheet.DrawingViews.Count = 0 Then
        GoTo NOVIEW2
    End If
    
    Set oView = oSheet.DrawingViews(1)
    EXT = Right(FFILENAME2, 3)
    FDOCTYPE = IIf(FDOCTYPE = "", IIf(EXT = "ipt", "Part", IIf(EXT = "iam", "Assembly", FDOCTYPE)), FDOCTYPE)
NOVIEW2:

'    tb.SetPromptResultText textB, InputBox("DOCUMENT TYPE", , IIf(FDOCTYPE = "", "ASSEMBLY / PART / PART LIST / TECH NOTES", FDOCTYPE))
    
    Set textB = tb.Definition.Sketch.TextBoxes(9)
    Set xml = New DOMDocument
    Call xml.loadXML(textB.FormattedText)
    Set node = xml.selectSingleNode("Prompt")
    If Not node Is Nothing Then
        FPOS = tb.GetResultText(textB)
        Debug.Print "POS:" + FPOS
    End If
    
'    tb.SetPromptResultText textB, InputBox("PART CODE", , FPARTCODE)
        
    Set textB = tb.Definition.Sketch.TextBoxes(11)
    Set xml = New DOMDocument
    Call xml.loadXML(textB.FormattedText)
    Set node = xml.selectSingleNode("Prompt")
    If Not node Is Nothing Then
        FQUANTITY = tb.GetResultText(textB)
        Debug.Print "QUANTITY:" + FQUANTITY
    End If
    If FDOCTYPE = "Part" Or FDOCTYPE = "Assembly" Then
'        tb.SetPromptResultText textB, InputBox("QUANTITY", , FQUANTITY)
    Else
'        tb.SetPromptResultText textB, ""
    End If
    
    Set textB = tb.Definition.Sketch.TextBoxes(29)
    Set xml = New DOMDocument
    Call xml.loadXML(textB.FormattedText)
    Set node = xml.selectSingleNode("Prompt")
    If Not node Is Nothing Then
        FMATERIAL = tb.GetResultText(textB)
        Debug.Print "MATERIAL:" + FMATERIAL
    End If
    If FDOCTYPE = "Part" Then
'        tb.SetPromptResultText textB, InputBox("MATERIAL", , FMATERIAL)
    Else
'        tb.SetPromptResultText textB, ""
    End If
    
    Set textB = tb.Definition.Sketch.TextBoxes(40)
    Set xml = New DOMDocument
    Call xml.loadXML(textB.FormattedText)
    Set node = xml.selectSingleNode("Prompt")
    If Not node Is Nothing Then
        FSPECIFICATIONS2 = tb.GetResultText(textB)
        Debug.Print "SPECIFICATIONS2:" + FSPECIFICATIONS2
    End If
    If FDOCTYPE = "Part" Or FDOCTYPE = "Assembly" Then
'        tb.SetPromptResultText textB, InputBox("SPECIFICATIONS", , FSPECIFICATIONS2)
    Else
'        tb.SetPromptResultText textB, ""
    End If
    
    Set textB = tb.Definition.Sketch.TextBoxes(35)
    Set xml = New DOMDocument
    Call xml.loadXML(textB.FormattedText)
    Set node = xml.selectSingleNode("Prompt")
    If Not node Is Nothing Then
        FPARTTYPE = tb.GetResultText(textB)
        Debug.Print "PARTTYPE:" + FPARTTYPE
    End If
    If FDOCTYPE = "Part" Then
'    tb.SetPromptResultText textB, InputBox("PART TYPE", , IIf(FPARTTYPE = "", "Production / Standard / Buy", FPARTTYPE))
    Else
'    tb.SetPromptResultText textB, ""
    End If
    
    Set textB = tb.Definition.Sketch.TextBoxes(34)
    Set xml = New DOMDocument
    Call xml.loadXML(textB.FormattedText)
    Set node = xml.selectSingleNode("Prompt")
    If Not node Is Nothing Then
        FPOSOLD = tb.GetResultText(textB)
        Debug.Print "POSOLD:" + FPOSOLD
    End If
    If FDOCTYPE = "Part" Or FDOCTYPE = "Assembly" Then
'        tb.SetPromptResultText textB, InputBox("POS. OLD", , FPOSOLD)
    Else
'        tb.SetPromptResultText textB, ""
    End If
    
    Set textB = tb.Definition.Sketch.TextBoxes(30)
    Set xml = New DOMDocument
    Call xml.loadXML(textB.FormattedText)
    Set node = xml.selectSingleNode("Prompt")
    If Not node Is Nothing Then
        FSCALE = Trim(tb.GetResultText(textB))
        If FSCALE = "" Then
            If oSheet.DrawingViews.Count > 0 Then
                FSCALE = FormatAsFraction(oSheet.DrawingViews(1).Scale)
            End If
        End If
        
        Debug.Print "SCALE:" + FSCALE
    End If
    
    Set textB = tb.Definition.Sketch.TextBoxes(38)
    Set xml = New DOMDocument
    Call xml.loadXML(textB.FormattedText)
    Set node = xml.selectSingleNode("Prompt")
    If Not node Is Nothing Then
        FNOTES = tb.GetResultText(textB)
        Debug.Print "NOTES:" + FNOTES
    End If
    
    
'    tb.SetPromptResultText textB, InputBox("SCALE", , IIf(FSCALE = "", "1:1", FSCALE))
Dim PS As PropertySet
Set PS = oDrawDoc.PropertySets("Inventor User Defined Properties")
FPROJECT = PS("PROJECT").Value
FCREATED = PS("DESIGNER").Value
FAPPROVED = PS("APPROVED BY").Value
FVERSION = PS("VERSION").Value
FCRDATE = PS("CREATION DATE").Value
FDEVELOPED = PS("DEVELOPED BY").Value
FREDESIGNED = PS("REDESIGNED BY").Value
FSUPPORTED = PS("SUPPORTED BY").Value
FLICENCE = PS("LICENCE").Value
    
End Sub

Public Function FormatAsFraction(numberIn As Double, Optional sep As String = ":") As String
Const epsilon As Double = 0.000001
Dim numerator As Integer
Dim denominator As Integer
Dim I As Integer
Dim testValue As Double

denominator = 0
'
' Because we only want fractions with small numbers,
' we use a loop that only goes to 100 (2-digit numbers)
'
For I = 1 To 100
'
' Multiply the input by a potential denominator
'
testValue = numberIn * CDbl(I)
'
' If the result is close enough to an integer, well use
' this denominator
'
If (testValue - Int(testValue + epsilon)) < epsilon Then
denominator = I
Exit For
End If
Next I
'
' If we found a suitable denominator, format the result
'
If denominator <> 0 Then
numerator = CInt(numberIn * denominator)
FormatAsFraction = Format(numerator, "0") & " " & sep & " " & Format(denominator, "0")
Else
'
' If theres no suitable denominator, format the input as a pseudo-fraction
'
FormatAsFraction = Format(numberIn, "0.0#####") & "/1"
End If
End Function



Sub BLOCKS_TO_PARTLIST()
    'Before running this code, add reference to Microsoft XML 6.0 in this VBA project
    Dim oDrawDoc As DrawingDocument
    Set oDrawDoc = ThisApplication.ActiveDocument
    Dim oSheet As Sheet
    Dim oView As DrawingView
    Dim tb As TitleBlock
    Dim textB As TextBox
    Dim xml As DOMDocument
    Dim node As IXMLDOMNode
    
    Dim FSHEET As String
    Dim FDOCTYPE As String, FPARTCODE As String, FQUANTITY As String, FMATERIAL As String, FSPECIFICATIONS2 As String, FPARTTYPE As String, FPOSOLD As String, FFILENAME As String, FPARTNAME As String
    
    Dim oCustomTable As CustomTable
    Dim oRow As Row
    
    
    
    If oDrawDoc.ActiveSheet.CustomTables.Count = 0 Then
    MsgBox "ACTIVATE A PARTS LIST SHEET BEfORE"
    Exit Sub
    Else
    Set oCustomTable = oDrawDoc.ActiveSheet.CustomTables(1)
    TT = UCase(oCustomTable.Title)
    oCustomTable.Title = IIf(TT = "PART LIST", "PARTS LIST", TT)
    If oCustomTable.Title <> "PARTS LIST" Then
    MsgBox "ACTIVATE A PARTS LIST SHEET BEfORE"
    Exit Sub
    End If
    End If
    
   
    
    For Each oRow In oCustomTable.Rows
        oRow.Delete
    Next oRow
    
    PC = IIf(PC = "", "A1", PC)
    
    ST = InputBox("START TABLE ON ITEM", , PC)
    
    C = 0
    
    BND = False: BNDP = False
    
    CHOOSE_COLUMNS
    
    ZERO_CHECK2
    
    For Each oSheet In oDrawDoc.Sheets
        
        Set tb = oSheet.TitleBlock
        
        Set textB = tb.Definition.Sketch.TextBoxes(35)
        Set xml = New DOMDocument
        Call xml.loadXML(textB.FormattedText)
        Set node = xml.selectSingleNode("Prompt")
        If Not node Is Nothing Then
            FPARTTYPE = tb.GetResultText(textB)
            Debug.Print "PARTTYPE:" + FPARTTYPE
        End If
        
        If FPARTTYPE = "Standard" Or FPARTTYPE = "Buy" Then
        FSHEET = ""
        Else
        C = 1 + C
        FSHEET = Str$(C)
        End If

'        If C < ST Then
'            GoTo next_sh
'        End If

'        FSHEET = Mid(oSheet.Name, InStr(1, oSheet.Name, ":") + 1)
        
        Set textB = tb.Definition.Sketch.TextBoxes(10)
        Set xml = New DOMDocument
        Call xml.loadXML(textB.FormattedText)
        Set node = xml.selectSingleNode("Prompt")
        If Not node Is Nothing Then
            FDOCTYPE = tb.GetResultText(textB)
            Debug.Print "DOCTYPE:" + FDOCTYPE
        End If
        
        Set textB = tb.Definition.Sketch.TextBoxes(9)
        Set xml = New DOMDocument
        Call xml.loadXML(textB.FormattedText)
        Set node = xml.selectSingleNode("Prompt")
        If Not node Is Nothing Then
            FPARTCODE = tb.GetResultText(textB)
            Debug.Print "PARTCODE:" + FPARTCODE
        End If
        
        If (Not BNDP) Then
            If FPARTCODE <> ST Then
                GoTo next_sh
            Else
                BNDP = True
            End If
        End If
            
        Set textB = tb.Definition.Sketch.TextBoxes(11)
        Set xml = New DOMDocument
        Call xml.loadXML(textB.FormattedText)
        Set node = xml.selectSingleNode("Prompt")
        If Not node Is Nothing Then
            FQUANTITY = tb.GetResultText(textB)
            Debug.Print "QUANTITY:" + FQUANTITY
        End If
        
        Set textB = tb.Definition.Sketch.TextBoxes(29)
        Set xml = New DOMDocument
        Call xml.loadXML(textB.FormattedText)
        Set node = xml.selectSingleNode("Prompt")
        If Not node Is Nothing Then
            FMATERIAL = tb.GetResultText(textB)
            Debug.Print "MATERIAL:" + FMATERIAL
        End If
        
        Set textB = tb.Definition.Sketch.TextBoxes(40)
        Set xml = New DOMDocument
        Call xml.loadXML(textB.FormattedText)
        Set node = xml.selectSingleNode("Prompt")
        If Not node Is Nothing Then
            FSPECIFICATIONS2 = tb.GetResultText(textB)
            Debug.Print "SPECIFICATIONS2:" + FSPECIFICATIONS2
        End If
                
        Debug.Print "SHEET:" + FSHEET
        
'        Set textB = tb.Definition.Sketch.TextBoxes(35)
'        Set xml = New DOMDocument
'        Call xml.loadXML(textB.FormattedText)
'        Set node = xml.selectSingleNode("Prompt")
'        If Not node Is Nothing Then
'            FPOSOLD = tb.GetResultText(textB)
'            Debug.Print "POSOLD:" + FPOSOLD
'        End If

        Set textB = tb.Definition.Sketch.TextBoxes(28)
        Set xml = New DOMDocument
        Call xml.loadXML(textB.FormattedText)
        Set node = xml.selectSingleNode("Prompt")
        If Not node Is Nothing Then
            FFILENAME = tb.GetResultText(textB)
            Debug.Print "FILENAME:" + FFILENAME
        End If
        
        Set textB = tb.Definition.Sketch.TextBoxes(27)
        Set xml = New DOMDocument
        Call xml.loadXML(textB.FormattedText)
        Set node = xml.selectSingleNode("Prompt")
        If Not node Is Nothing Then
            FPARTNAME = tb.GetResultText(textB)
            Debug.Print "PARTNAME:" + FPARTNAME
        End If
        
        If FDOCTYPE = "Parts list" Then
            FPARTNAME = "Parts list"
            Debug.Print "PARTNAME:" + FPARTNAME
        End If
        
        If FDOCTYPE = "Technical notes" Then
            FPARTNAME = "Technical notes"
            Debug.Print "PARTNAME:" + FPARTNAME
        End If
        
        Set textB = tb.Definition.Sketch.TextBoxes(38)
        Set xml = New DOMDocument
        Call xml.loadXML(textB.FormattedText)
        Set node = xml.selectSingleNode("Prompt")
        If Not node Is Nothing Then
            FNOTES = tb.GetResultText(textB)
            Debug.Print "NOTES:" + FNOTES
        End If
        
        
        
        Set oRow = oCustomTable.Rows.Add
        
        
        oRow.Item(1).Value = FPARTCODE
'        oRow.Item(2).Value = FPOSOLD
        oRow.Item(2).Value = FQUANTITY
        oRow.Item(3).Value = FPARTNAME
        oRow.Item(4).Value = FFILENAME
        oRow.Item(5).Value = FPARTTYPE
        oRow.Item(6).Value = FSPECIFICATIONS2
        oRow.Item(7).Value = FSHEET

'        If oCustomTable.Columns.Count = 7 Then
'        oCustomTable.Columns.Add "MATERIAL"
'        End If
        
        
        oRow.Item(8).Value = FMATERIAL
        oRow.Item(9).Value = FNOTES
        
        
'        If FPARTTYPE = "Standard" Or FPARTTYPE = "Buy" Then
'        sep = IIf((FPARTNAME = "") Or (FSPECIFICATIONS2 = ""), "", ", ")
'        oRow.Item(6).Value = FPARTNAME + sep + FSPECIFICATIONS2
'        End If
'
'        If FDOCTYPE = "Part" Then
'        sep = IIf((oRow.Item(6).Value = "") Or (FMATERIAL = ""), "", ", ")
'        oRow.Item(6).Value = oRow.Item(6).Value + sep + FMATERIAL
'        End If
        
        If oCustomTable.RangeBox.MinPoint.Y <= 5.3 Then
            oRow.Delete
            BND = True
            PC = FPARTCODE
            Exit For
        Else
            
        End If
        
next_sh:
    Next oSheet
    
    If BND Then
        MsgBox "TABLE DIVIDED, REPEAT THIS MACRO IN THE NEXT PARTS LIST PAGE STARTING ON ITEM " & PC
    Else
        PC = "A1"
        PC2 = 1
    End If
End Sub

Sub BLOCKS_TO_PARTLIST2()
    'Before running this code, add reference to Microsoft XML 6.0 in this VBA project
    Dim oDrawDoc As DrawingDocument
    Set oDrawDoc = ThisApplication.ActiveDocument
    Dim oSheet As Sheet
    Dim oView As DrawingView
    Dim tb As TitleBlock
    Dim textB As TextBox
    Dim xml As DOMDocument
    Dim node As IXMLDOMNode
    
    Dim FSHEET As String
'    Dim FDOCTYPE As String, FPARTCODE As String, FQUANTITY As String, FMATERIAL As String, FSPECIFICATIONS2 As String, FPARTTYPE As String, FPOSOLD As String, FFILENAME As String, FPARTNAME As String
    
    Dim oCustomTable As CustomTable
    Dim oRow As Row
    Dim SHX As Sheet
    
    CHOOSE_COLUMNS
    
    For Each SHX In oDrawDoc.Sheets
    
     For Each oCustomTable In SHX.CustomTables
    
'    If oCustomTable.Title = "PART LIST" Then
'        oCustomTable.Title = "PARTS LIST"
'    End If
    
    If UCase(oCustomTable.Title) <> "PARTS LIST" Then GoTo next_table
    
'    BND = False: BNDP = False
    
        Set oSheet = SHEETx(Val(FSHEETg))
        
        Dim rowx As Row
        
        Set oRow = Nothing
        For Each rowx In oCustomTable.Rows
            PC = rowx.Item(1).Value
            If PC = FPOS Then
                Set oRow = rowx
                Exit For
            End If
        Next rowx
        
        If oRow Is Nothing Then
'            MsgBox "Item not found in parts list"
            GoTo next_table
        End If
        
        oRow.Item(1).Value = FPOS
'        oRow.Item(2).Value = FPOSOLD
        oRow.Item(2).Value = FQUANTITY
        oRow.Item(3).Value = FPARTNAME
        oRow.Item(4).Value = FFILENAME
        oRow.Item(5).Value = FPARTTYPE
        oRow.Item(6).Value = FSPECIFICATIONS2
        oRow.Item(7).Value = FSHEETg

'        If oCustomTable.Columns.Count = 7 Then
'        oCustomTable.Columns.Add "MATERIAL"
'        End If

        
        
        oRow.Item(8).Value = FMATERIAL
        oRow.Item(9).Value = FNOTES
        
'        If FPARTTYPE = "Standard" Or FPARTTYPE = "Buy" Then
'        sep = IIf((FPARTNAME = "") Or (FSPECIFICATIONS2 = ""), "", ", ")
'        oRow.Item(6).Value = FPARTNAME + sep + FSPECIFICATIONS2
'        End If
'
'        If FDOCTYPE = "Part" Then
'        sep = IIf((oRow.Item(6).Value = "") Or (FMATERIAL = ""), "", ", ")
'        oRow.Item(6).Value = oRow.Item(6).Value + sep + FMATERIAL
'        End If
        
next_table:
Next oCustomTable

Next SHX
        

End Sub


Sub PAGES()
Dim oDoc As DrawingDocument, SHX As Sheet, TBX As CustomTable, TBLX As TitleBlock, SHX2 As Sheet, ORW As Row
Set oDoc = ThisDocument
For Each SHX In oDoc.Sheets
For Each TBX In SHX.CustomTables
If UCase(TBX.Title) <> "PARTS LIST" Then GoTo next_table
F = 0
For Each SHX2 In oDoc.Sheets
SHX2.Name = NSH0(SHX2.Name)
FX = 0
For Each ORW In TBX.Rows
FX = 1 + FX
If FX <= F Then GoTo NEXT_F
FSHEET1 = Trim(ORW.Item(7).Value)
POS1 = Trim(ORW.Item(1).Value)
Set TBLX = SHX2.TitleBlock

    FSHEET2 = NSH(SHX2.Name) 'Trim(Mid(SHX2.Name, InStr(1, SHX2.Name, ":") + 1))
    Set textB = TBLX.Definition.Sketch.TextBoxes(9)
    Set xml = New DOMDocument
    Call xml.loadXML(textB.FormattedText)
    Set node = xml.selectSingleNode("Prompt")
    If Not node Is Nothing Then
        POS2 = Trim(TBLX.GetResultText(textB))
    End If
    
    If POS1 = POS2 Then
    ORW.Item(7).Value = FSHEET2
    F = FX
    Exit For
    End If
NEXT_F:
Next ORW
Next SHX2
next_table:
Next TBX
Next SHX
End Sub

Sub TCASE(Optional void As Integer)
'On Error Resume Next
'Dim ODOC As DrawingDocument, SHX As Sheet, TBX As CustomTable, TBLX As TitleBlock, SHX2 As Sheet, ORW As Row
'Set ODOC = ThisDocument
'For Each SHX In ODOC.Sheets
'For Each TBX In SHX.CustomTables
'If UCase(TBX.Title) <> "PARTS LIST" Then GoTo next_table
'For Each ORW In TBX.Rows
'
'ORW.Item(3).Value = TCASEX(ORW.Item(3).Value)
'ORW.Item(6).Value = TCASEX(ORW.Item(6).Value)
'
'If TBX.Columns.Count > 7 Then
'ORW.Item(8).Value = TCASEX(ORW.Item(8).Value)
'End If
'
'If TBX.Columns.Count > 8 Then
'ORW.Item(9).Value = TCASEX(ORW.Item(9).Value)
'End If
'
'Next ORW
'next_table:
'Next TBX
'Next SHX
'
'If Err.Number = -2147467259 Then
'Err.Clear
'ElseIf Err.Number <> 0 Then
'Err.Raise (Err.Number)
'End
'End If


End Sub

Function TCASEX(STRX As String) As String
'STRX = Trim(STRX)
TCASEX = STRX
'If STRX = "" Then
'TCASEX = ""
'Exit Function
'End If
'C1 = UCase(Left(STRX, 1))
'C2 = LCase(Right(STRX, Len(STRX) - 1))
'TCASEX = C1 + C2
'TCASEX = Replace(TCASEX, "3d ", "3D ")
'TCASEX = Replace(TCASEX, "din ", "DIN ")
'TCASEX = Replace(TCASEX, "iso ", "ISO ")
End Function

Function NSH(SN As String) As String
If InStr(1, SN, ":") > 0 Then
NSH = Trim(Mid(SN, InStr(1, SN, ":") + 1))
Else
NSH = ""
End If
End Function

Function NSH0(SN As String) As String
P = InStr(1, SN, ":")
If P > 0 Then
NSH0 = Mid(SN, 1, P - 1)
Else
NSH0 = SN
End If
NSH0 = Trim(NSH0)
End Function

Sub SET_FIELDS1(Optional void As Integer)
'Before running this code, add reference to Microsoft XML 6.0 in this VBA project
Dim oDrawDoc As DrawingDocument
Set oDrawDoc = ThisApplication.ActiveDocument
Dim oSheet As Sheet
Dim oView As DrawingView
Dim tb As TitleBlock
Dim textB As TextBox
Dim xml As DOMDocument
Dim node As IXMLDOMNode

Dim FSHEET As String

Set oSheet = oDrawDoc.ActiveSheet
FSHEET = NSH(oSheet.Name) ' Mid(oSheet.Name, InStr(1, oSheet.Name, ":") + 1)
Debug.Print "SHEET:" + FSHEET
FSHEETg = FSHEET

Set tb = oSheet.TitleBlock

Set textB = tb.Definition.Sketch.TextBoxes(28)
tb.SetPromptResultText textB, FFILENAME

Set textB = tb.Definition.Sketch.TextBoxes(27)
tb.SetPromptResultText textB, FPARTNAME

Set textB = tb.Definition.Sketch.TextBoxes(10)
tb.SetPromptResultText textB, FDOCTYPE

Set textB = tb.Definition.Sketch.TextBoxes(9)
tb.SetPromptResultText textB, FPOS

Set textB = tb.Definition.Sketch.TextBoxes(11)
tb.SetPromptResultText textB, FQUANTITY

Set textB = tb.Definition.Sketch.TextBoxes(29)
tb.SetPromptResultText textB, FMATERIAL

Set textB = tb.Definition.Sketch.TextBoxes(40)
tb.SetPromptResultText textB, FSPECIFICATIONS2

Set textB = tb.Definition.Sketch.TextBoxes(35)
tb.SetPromptResultText textB, FPARTTYPE

Set textB = tb.Definition.Sketch.TextBoxes(34)
tb.SetPromptResultText textB, FPOSOLD

Set textB = tb.Definition.Sketch.TextBoxes(30)
tb.SetPromptResultText textB, FSCALE

Set textB = tb.Definition.Sketch.TextBoxes(38)
tb.SetPromptResultText textB, FNOTES

'i = 0
'For Each textB In tb.Definition.Sketch.TextBoxes
'i = 1 + i
'Debug.Print i
'Debug.Print textB.FormattedText
'Next textB

If FPARTTYPE = "Standard" Or FPARTTYPE = "Buy" Then
oSheet.ExcludeFromCount = True
oSheet.ExcludeFromPrinting = True
Else
oSheet.ExcludeFromCount = False
oSheet.ExcludeFromPrinting = False
End If

oSheet.Name = IIf(FPOS = "", oSheet.Name, FPOS)



oSheet.Activate
oDrawDoc.Update

Call BLOCKS_TO_PARTLIST2

End Sub

Sub SET_FIELDS1_2(Optional oSheet As Sheet)
'Before running this code, add reference to Microsoft XML 6.0 in this VBA project
Dim oDrawDoc As DrawingDocument
Set oDrawDoc = ThisApplication.ActiveDocument
'Dim oSheet As Sheet
Dim oView As DrawingView
Dim tb As TitleBlock
Dim textB As TextBox
Dim xml As DOMDocument
Dim node As IXMLDOMNode

'FPOS = FPARTCODE

If oSheet Is Nothing Then
Set oSheet = SHEETx(CInt(FSHEETg))
End If

If oSheet Is Nothing Then Exit Sub

Set tb = oSheet.TitleBlock

Set textB = tb.Definition.Sketch.TextBoxes(28)
tb.SetPromptResultText textB, FFILENAME

Set textB = tb.Definition.Sketch.TextBoxes(27)
tb.SetPromptResultText textB, FPARTNAME

'Set textB = tb.Definition.Sketch.TextBoxes(10)
'tb.SetPromptResultText textB, FDOCTYPE

Set textB = tb.Definition.Sketch.TextBoxes(9)
tb.SetPromptResultText textB, FPOS

Set textB = tb.Definition.Sketch.TextBoxes(11)
tb.SetPromptResultText textB, FQUANTITY


Set textB = tb.Definition.Sketch.TextBoxes(29)
tb.SetPromptResultText textB, FMATERIAL

Set textB = tb.Definition.Sketch.TextBoxes(38)
tb.SetPromptResultText textB, FNOTES

Set textB = tb.Definition.Sketch.TextBoxes(40)
tb.SetPromptResultText textB, FSPECIFICATIONS2


Set textB = tb.Definition.Sketch.TextBoxes(35)
tb.SetPromptResultText textB, FPARTTYPE

'Set textB = tb.Definition.Sketch.TextBoxes(31)
'tb.SetPromptResultText textB, FSCALE

'Set textB = tb.Definition.Sketch.TextBoxes(41)
'tb.SetPromptResultText textB, FNOTES

If FPARTTYPE = "Standard" Or FPARTTYPE = "Buy" Then
oSheet.ExcludeFromCount = True
oSheet.ExcludeFromPrinting = True
Else
oSheet.ExcludeFromCount = False
oSheet.ExcludeFromPrinting = False
End If

'DoEvents
'
'oDrawDoc.Update

oSheet.Name = IIf(FPOS = "", oSheet.Name, FPOS)

    
End Sub

Sub SET_FIELDS1_3(Optional void As Integer)
'Before running this code, add reference to Microsoft XML 6.0 in this VBA project
Dim oDrawDoc As DrawingDocument
Set oDrawDoc = ThisApplication.ActiveDocument
Dim oSheet As Sheet
Dim oView As DrawingView
Dim tb As TitleBlock
Dim textB As TextBox
Dim xml As DOMDocument
Dim node As IXMLDOMNode

'FPOS = FPARTCODE

Set oSheet = oDrawDoc.ActiveSheet '  SHEETx(CInt(FSHEETg))

If oSheet Is Nothing Then Exit Sub

Set tb = oSheet.TitleBlock

Set textB = tb.Definition.Sketch.TextBoxes(28)
tb.SetPromptResultText textB, FFILENAME

Set textB = tb.Definition.Sketch.TextBoxes(27)
tb.SetPromptResultText textB, FPARTNAME

Set textB = tb.Definition.Sketch.TextBoxes(10)
tb.SetPromptResultText textB, FDOCTYPE

Set textB = tb.Definition.Sketch.TextBoxes(9)
tb.SetPromptResultText textB, FPOS

Set textB = tb.Definition.Sketch.TextBoxes(11)
tb.SetPromptResultText textB, FQUANTITY


Set textB = tb.Definition.Sketch.TextBoxes(29)
tb.SetPromptResultText textB, FMATERIAL

Set textB = tb.Definition.Sketch.TextBoxes(40)
tb.SetPromptResultText textB, FSPECIFICATIONS2


Set textB = tb.Definition.Sketch.TextBoxes(35)
tb.SetPromptResultText textB, FPARTTYPE

Set textB = tb.Definition.Sketch.TextBoxes(30)
tb.SetPromptResultText textB, FSCALE

Set textB = tb.Definition.Sketch.TextBoxes(38)
tb.SetPromptResultText textB, FNOTES

'If FPARTTYPE = "Standard" Or FPARTTYPE = "Buy" Then
'oSheet.ExcludeFromCount = True
'oSheet.ExcludeFromPrinting = True
'Else
'oSheet.ExcludeFromCount = False
'oSheet.ExcludeFromPrinting = False
'End If

'oSheet.Name = IIf(FPOS = "", oSheet.Name, FPOS)

    
End Sub


Sub MATERIAL_COLUMN_VIEW(Optional void As Integer)
Dim oDrawDoc As DrawingDocument
Dim SHX As Sheet
Dim oCustomTable As CustomTable

Set oDrawDoc = ThisApplication.ActiveDocument

CHOOSE_COLUMNS

For Each SHX In oDrawDoc.Sheets
For Each oCustomTable In SHX.CustomTables
If UCase(oCustomTable.Title) <> "PARTS LIST" Then GoTo next_table
oCustomTable.Columns(8).Width = 5
oCustomTable.Columns(9).Width = 10
next_table:
Next oCustomTable
Next SHX


End Sub


Sub CHOOSE_COLUMNS(Optional void As Integer)
On Error Resume Next
Dim oDrawDoc As DrawingDocument
Dim oSheet As Sheet, ctcol As Column
Dim oCustomTable As CustomTable, BNDM As Boolean, bndn As Boolean

Set oDrawDoc = ThisApplication.ActiveDocument


For Each oSheet In oDrawDoc.Sheets

BNDM = False
bndn = False

For Each oCustomTable In oSheet.CustomTables

If UCase(oCustomTable.Title) = "PART LIST" Then
    oCustomTable.Title = "PARTS LIST"
End If

If UCase(oCustomTable.Title) <> "PARTS LIST" Then GoTo next_table3

If (InStr(1, oCustomTable.Columns(2).Title, "POS") > 0) And (InStr(1, oCustomTable.Columns(2).Title, "OLD") > 0) Then
oCustomTable.Columns(2).Delete
End If

If oCustomTable.Columns.Count = 7 Then
Set ctcol = oCustomTable.Columns.Add("MATERIAL")
ctcol.Width = 0
BNDM = True
End If

If Err.Number = -2147418113 Then
Err.Clear
ElseIf Err.Number <> 0 Then
GoTo errx
End If

If oCustomTable.Columns.Count = 8 Then
Set ctcol = oCustomTable.Columns.Add("NOTES")
ctcol.Width = 0
bndn = True
End If

If Err.Number = -2147418113 Then
Err.Clear
ElseIf Err.Number <> 0 Then
GoTo errx
End If


If BNDM Or bndn Then
Call EXTEND_PARTLIST(oCustomTable)
End If




next_table3:
Next oCustomTable


'BNDN = False
'For Each oCustomTable In oSheet.CustomTables
'
'If UCase(oCustomTable.Title) = "TECHNICL NOTES" Then
'    oCustomTable.Title = "TECHNICAL NOTES"
'End If
'
'If UCase(oCustomTable.Title) <> "TECHNICAL NOTES" Then GoTo next_table4
'
'
'If oCustomTable.Columns.Count = 8 Then
'oCustomTable.Columns.Add "NOTES"
'BNDM = True
'
'If BNDN Then
'Call MATERIAL_TO_PARTLIST(oSheet)
'End If
'
'End If
'
'next_table4:
'Next oCustomTable

Next oSheet

errx:
If Err Then
Err.Raise (Err.Number)
End
End If

End Sub

Sub EXTEND_PARTLIST(oTb As CustomTable)
'Before running this code, add reference to Microsoft XML 6.0 in this VBA project
    Dim oDrawDoc As DrawingDocument
    Set oDrawDoc = ThisApplication.ActiveDocument
    Dim oSheet As Sheet
    Dim oView As DrawingView
    Dim tb As TitleBlock
    Dim textB As TextBox
    Dim xml As DOMDocument
    Dim node As IXMLDOMNode
    
    Dim FSHEET As String
    Dim FDOCTYPE As String, FPARTCODE As String, FQUANTITY As String, FMATERIAL As String, FSPECIFICATIONS2 As String, FPARTTYPE As String, FPOSOLD As String, FFILENAME As String, FPARTNAME As String
    
    Dim oCustomTable As CustomTable
    Dim oRow As Row
    
' Set oCustomTable = oDrawDoc.ActiveSheet.CustomTables(1)
    
' For Each oRow In oCustomTable.Rows
'     oRow.Delete
' Next oRow
    
    
' C = 0
    
    
    For Each oSheet In oDrawDoc.Sheets
'    Set oSheet = sh
        
        If oTb.Rows.Count = 0 Then GoTo next_sh
        
        FSHEET = NSH(oSheet.Name) ' Mid(oSheet.Name, InStr(1, oSheet.Name, ":") + 1)
        
        Set tb = oSheet.TitleBlock
        
        
        Set textB = tb.Definition.Sketch.TextBoxes(29)
        Set xml = New DOMDocument
        Call xml.loadXML(textB.FormattedText)
        Set node = xml.selectSingleNode("Prompt")
        If Not node Is Nothing Then
            FMATERIAL = tb.GetResultText(textB)
            Debug.Print "MATERIAL:" + FMATERIAL
        End If
        
        
        Set textB = tb.Definition.Sketch.TextBoxes(38)
        Set xml = New DOMDocument
        Call xml.loadXML(textB.FormattedText)
        Set node = xml.selectSingleNode("Prompt")
        If Not node Is Nothing Then
            FNOTES = tb.GetResultText(textB)
            Debug.Print "NOTES:" + FNOTES
        End If
        
        
        If (FMATERIAL <> "") Or (FNOTES <> "") Then
'            For Each oCustomTable In sh.CustomTables
             Set oCustomTable = oTb
                For Each oRow In oCustomTable.Rows
                
                If FSHEET <> "" Then
                    P = InStr(1, FSHEET, "-")
                    If P = 0 Then
                        i1 = FSHEET
                        i2 = FSHEET
                    Else
                        i1 = Mid(FSHEET, 1, P - 1)
                        i2 = Mid(FSHEET, P + 1)
                    End If
                    
                    For I = Val(i1) To Val(i2)
                        FSHEETgx = I
                        
                        oRow.Item(7).Value = Trim(oRow.Item(7).Value)
                        
                        If oRow.Item(7).Value = FSHEETgx Then
                            oRow.Item(8).Value = IIf(FMATERIAL <> "", FMATERIAL, oRow.Item(8).Value)
                            oRow.Item(9).Value = IIf(FNOTES <> "", FNOTES, oRow.Item(9).Value)
                            GoTo next_sh
                        End If
            
                    Next I
                End If
                
                Next oRow
'            Next oCustomTable
        End If
        
        

next_sh:
        Next oSheet
        
    End Sub
    



Sub MATERIAL_COLUMN_HIDE(Optional void As Integer)
Dim oDrawDoc As DrawingDocument
Dim SHX As Sheet
Dim oCustomTable As CustomTable

Set oDrawDoc = ThisApplication.ActiveDocument

CHOOSE_COLUMNS



For Each SHX In oDrawDoc.Sheets
For Each oCustomTable In SHX.CustomTables
If UCase(oCustomTable.Title) <> "PARTS LIST" Then GoTo next_table
oCustomTable.Columns(8).Width = 0
oCustomTable.Columns(9).Width = 0
next_table:
Next oCustomTable
Next SHX


End Sub

Sub MATERIAL_COLUMN_DELETE(Optional void As Integer)
Dim oDrawDoc As DrawingDocument
Dim SHX As Sheet
Dim oCustomTable As CustomTable

Set oDrawDoc = ThisApplication.ActiveDocument

'CHOOSE_COLUMNS

For Each SHX In oDrawDoc.Sheets
For Each oCustomTable In SHX.CustomTables
If UCase(oCustomTable.Title) = "PART LIST" Then
    oCustomTable.Title = "PARTS LIST"
End If
If UCase(oCustomTable.Title) <> "PARTS LIST" Then GoTo next_table
If oCustomTable.Columns.Count > 7 Then
oCustomTable.Columns(8).Delete
oCustomTable.Columns(9).Delete
End If
next_table:
Next oCustomTable
Next SHX


End Sub



Sub SET_FIELDS2(Optional void As Integer)
Dim oDrawDoc As DrawingDocument
Dim oSheet As Sheet
Set oDrawDoc = ThisApplication.ActiveDocument
Set oSheet = oDrawDoc.ActiveSheet
Dim PS As PropertySet
Set PS = oDrawDoc.PropertySets("Inventor User Defined Properties")
PS("PROJECT").Value = FPROJECT
PS("DESIGNER").Value = FCREATED
PS("APPROVED BY").Value = FAPPROVED
PS("VERSION").Value = FVERSION
PS("CREATION DATE").Value = FCRDATE
PS("DEVELOPED BY").Value = FDEVELOPED
PS("REDESIGNED BY").Value = FREDESIGNED
PS("SUPPORTED BY").Value = FSUPPORTED
PS("LICENCE").Value = FLICENCE
'oSheet.Activate
oDrawDoc.Update
End Sub

Sub UPDATE_FIELDS()
UserForm1.Show
End Sub

Sub PARTLIST_TO_BLOCKS()
On Error Resume Next
Dim oDrawDoc As DrawingDocument
Dim oSheet As Sheet
Dim tb As TitleBlock
Dim textB As TextBox
Dim xml As DOMDocument
Dim node As IXMLDOMNode
Dim FSHEET As String
Dim oCustomTable As CustomTable


Set oDrawDoc = ThisApplication.ActiveDocument

CHOOSE_COLUMNS

ZERO_CHECK
TCASE



For Each oSheet In oDrawDoc.Sheets

For Each oCustomTable In oSheet.CustomTables

'umat = MsgBox("Separate material from specs and update", vbYesNo, "Update material?")

If UCase(oCustomTable.Title) <> "PARTS LIST" Then GoTo next_table

For Each oRow In oCustomTable.Rows

    FPOS = ""
    FPARTCODE = ""
    FQUANTITY = ""
    FPARTNAME = ""
    FFILENAME = ""
    FPARTTYPE = ""
    FSPECIFICATIONS2 = ""
    FSHEET = ""
    FMATERIAL = ""
    FNOTES = ""

    FPOS = Trim(oRow.Item(1).Value)
    FPARTCODE = Trim(FPOS)
    FQUANTITY = Trim(oRow.Item(2).Value)
    FPARTNAME = Trim(oRow.Item(3).Value)
    FFILENAME = Trim(oRow.Item(4).Value)
    FPARTTYPE = Trim(oRow.Item(5).Value)
    FSPECIFICATIONS2 = Trim(oRow.Item(6).Value)
    FSHEET = Trim(oRow.Item(7).Value)
       
'    If oCustomTable.Columns.Count = 7 Then
'    oCustomTable.Columns.Add "MATERIAL"
'    End If
 
    FMATERIAL = Trim(oRow.Item(8).Value)
    FNOTES = Trim(oRow.Item(9).Value)
    
If Err.Number = -2147467259 Then
    Err.Clear
    ElseIf Err.Number <> 0 Then
    GoTo ERRPTB
    End If
    
    
    If FSHEET <> "" Then
        P = InStr(1, FSHEET, "-")
        If P = 0 Then
            i1 = FSHEET
            i2 = FSHEET
        Else
            i1 = Mid(FSHEET, 1, P - 1)
            i2 = Mid(FSHEET, P + 1)
        End If
        
        For I = Val(i1) To Val(i2)
            FSHEETg = I
            Call SET_FIELDS1_2
'            sep = IIf((FSPECIFICATIONS2 = "") Or (FMATERIAL = ""), "", ", ")
'            oRow.Item(6).Value = FSPECIFICATIONS2 + sep + FMATERIAL
        Next I
    Else
        Dim SHX As Sheet, TBLX As TitleBlock, SHX2 As Sheet
        Set SHX2 = Nothing
        For Each SHX In oDrawDoc.Sheets
            Set TBLX = SHX.TitleBlock
            Set textB = TBLX.Definition.Sketch.TextBoxes(9)
            Set xml = New DOMDocument
            Call xml.loadXML(textB.FormattedText)
            Set node = xml.selectSingleNode("Prompt")
            If Not node Is Nothing Then
                POSX = Trim(TBLX.GetResultText(textB))
            End If
            If FPOS = POSX Then
                Set SHX2 = SHX
                Exit For
            End If
        Next SHX
        If Not (SHX2 Is Nothing) Then
            Call SET_FIELDS1_2(SHX2)
        End If
    End If
    
Next oRow

next_table:

Next oCustomTable

Next oSheet

ERRPTB:

If Err Then
Err.Raise (Err.Number)
End
End If



End Sub


'Sub join_test()
'Dim fullName As String
'Dim names(0 To 2) As String
'names(0) = ""
'names(1) = ""
'fullName = Join(names, ", ")
'Debug.Print fullName
'End Sub

Sub TRANSLATE_LABELS_ES(Optional void As Integer)
    Dim oDrawDoc As DrawingDocument
    Set oDrawDoc = ThisApplication.ActiveDocument

    Dim oTitleBlockDef As TitleBlockDefinition
    Set oTitleBlockDef = oDrawDoc.ActiveSheet.TitleBlock.Definition  ' oDrawDoc.TitleBlockDefinitions.Item("oho_title-block1")
    
    Dim oSketch As DrawingSketch
    oTitleBlockDef.Edit oSketch
    
'    Dim tb As TextBox
'    i = 0
'    For Each tb In oSketch.TextBoxes
'    i = 1 + i
'    Debug.Print i & "    " & tb.FormattedText
'    Next tb
    
    oSketch.TextBoxes(1).FormattedText = "FECHA"
    oSketch.TextBoxes(4).FormattedText = "DESARROLLADO POR"
    oSketch.TextBoxes(5).FormattedText = "REDISEADO POR"
    oSketch.TextBoxes(14).FormattedText = "PROYECTO"
    oSketch.TextBoxes(15).FormattedText = "CREADO POR"
    oSketch.TextBoxes(16).FormattedText = "APROBADO POR"
    oSketch.TextBoxes(17).FormattedText = "LICENCIA"
    oSketch.TextBoxes(18).FormattedText = "NOMBRE DE PIEZA"
    oSketch.TextBoxes(19).FormattedText = "CDIGO"
    oSketch.TextBoxes(20).FormattedText = "TIPO DOC."
    oSketch.TextBoxes(21).FormattedText = "VERSIN"
    oSketch.TextBoxes(22).FormattedText = "NOMBRE DE ARCHIVO"
    oSketch.TextBoxes(23).FormattedText = "MATERIAL"
    oSketch.TextBoxes(24).FormattedText = "HOJA"
    oSketch.TextBoxes(25).FormattedText = "ESCALA"
    oSketch.TextBoxes(26).FormattedText = "CANTIDAD"
    oSketch.TextBoxes(34).FormattedText = "APOYADO POR"
    oSketch.TextBoxes(38).FormattedText = "POS."
    oSketch.TextBoxes(39).FormattedText = "TIPO DE PIEZA"
    oSketch.TextBoxes(40).FormattedText = "ESPECIFICACIONES"
    
    oTitleBlockDef.ExitEdit True
    
    Dim PS As PropertySet
    Set PS = oDrawDoc.PropertySets("Inventor User Defined Properties")
    FPROJECT = Split(oDrawDoc.DisplayName, ".idw")(0) ' PS("PROJECT").Value
    PS("PROJECT").Value = NAME_ES '  InputBox("IN SPANISH", "PROJECT NAME", FPROJECT)
    
    Dim SHX As Sheet, oCustomTable As CustomTable
    
    
    CHOOSE_COLUMNS
    
    
    For Each SHX In oDrawDoc.Sheets
        For Each oCustomTable In SHX.CustomTables
        
'            If oCustomTable.Title = "PART LIST" Then
'                oCustomTable.Title = "PARTS LIST"
'            End If
    
            If UCase(oCustomTable.Title) <> "PARTS LIST" Then GoTo next_table2
            
'            If oCustomTable.Columns.Count = 7 Then
'                oCustomTable.Columns.Add "MATERIAL"
'            End If

            
            
            oCustomTable.Columns(2).Title = "CANT"
            oCustomTable.Columns(3).Title = "NOMBRE DE PIEZA"
            oCustomTable.Columns(4).Title = "NOMBRE DE ARCHIVO"
            oCustomTable.Columns(5).Title = "TIPO PZA"
            oCustomTable.Columns(6).Title = "ESPECIFICACIONES"
            oCustomTable.Columns(7).Title = "HOJA"
            
            oCustomTable.Columns(8).Width = 0

            
next_table2:
        Next oCustomTable
    Next SHX
    
    For Each SHX In oDrawDoc.Sheets
        For Each oCustomTable In SHX.CustomTables
        
'            If oCustomTable.Title = "PART LIST" Then
'                oCustomTable.Title = "PARTS LIST"
'            End If
    
            If UCase(oCustomTable.Title) <> "TECHNICAL NOTES" Then GoTo next_table3
            
'            If oCustomTable.Columns.Count = 7 Then
'                oCustomTable.Columns.Add "MATERIAL"
'            End If

            
            
            oCustomTable.Columns(1).Title = "NOTAS"
            oCustomTable.Columns(2).Title = "CONTENIDO"
            
            oCustomTable.ShowTitle = False
            
next_table3:
        Next oCustomTable
    Next SHX
    

    
End Sub

Sub TRANSLATE_LABELS_DE(Optional void As Integer)
    Dim oDrawDoc As DrawingDocument
    Set oDrawDoc = ThisApplication.ActiveDocument

    Dim oTitleBlockDef As TitleBlockDefinition
    Set oTitleBlockDef = oDrawDoc.ActiveSheet.TitleBlock.Definition  'oDrawDoc.TitleBlockDefinitions.Item("oho_title-block1")
    
    Dim oSketch As DrawingSketch
    oTitleBlockDef.Edit oSketch
    
'    Dim tb As TextBox
'    i = 0
'    For Each tb In oSketch.TextBoxes
'    i = 1 + i
'    Debug.Print i & "    " & tb.FormattedText
'    Next tb
    
oSketch.TextBoxes(1).FormattedText = "DATE"
oSketch.TextBoxes(4).FormattedText = "ENTWICKELT VON"
oSketch.TextBoxes(5).FormattedText = "UMGESTALTET VON"
oSketch.TextBoxes(14).FormattedText = "PROJEKT"
oSketch.TextBoxes(15).FormattedText = "ERSTELLT VON"
oSketch.TextBoxes(16).FormattedText = "GENEHMIGT VON"
oSketch.TextBoxes(17).FormattedText = "LIZENZ"
oSketch.TextBoxes(18).FormattedText = "TEIL-NAME"
oSketch.TextBoxes(19).FormattedText = "TEIL-CODE"
oSketch.TextBoxes(20).FormattedText = "DOK. TYP"
oSketch.TextBoxes(21).FormattedText = "VERSION"
oSketch.TextBoxes(22).FormattedText = "DATEI-NAME"
oSketch.TextBoxes(23).FormattedText = "WERKSTOFF"
oSketch.TextBoxes(24).FormattedText = "SEITE"
oSketch.TextBoxes(25).FormattedText = "SCALE"
oSketch.TextBoxes(26).FormattedText = "MENGE"
oSketch.TextBoxes(34).FormattedText = "UNTERSTUETZT DURCH"
oSketch.TextBoxes(38).FormattedText = "POS. OLD"
oSketch.TextBoxes(39).FormattedText = "TEIL-TYP"
oSketch.TextBoxes(40).FormattedText = "SPEZIFIKATIONEN"
    
    oTitleBlockDef.ExitEdit True
    
    Dim PS As PropertySet
    Set PS = oDrawDoc.PropertySets("Inventor User Defined Properties")
    FPROJECT = Split(oDrawDoc.DisplayName, ".idw")(0) ' PS("PROJECT").Value
    PS("PROJECT").Value = NAME_DE ' InputBox("IN GERMAN", "PROJECT NAME", FPROJECT)
    
    Dim SHX As Sheet, oCustomTable As CustomTable
    
    
    CHOOSE_COLUMNS
    
    For Each SHX In oDrawDoc.Sheets
        For Each oCustomTable In SHX.CustomTables
        
'            If oCustomTable.Title = "PART LIST" Then
'                oCustomTable.Title = "PARTS LIST"
'            End If
    
            If UCase(oCustomTable.Title) <> "PARTS LIST" Then GoTo next_table2
            
'            If oCustomTable.Columns.Count = 7 Then
'                oCustomTable.Columns.Add "MATERIAL"
'            End If

            
            
            oCustomTable.Columns(2).Title = "QTY"
            oCustomTable.Columns(3).Title = "TEIL NAME"
            oCustomTable.Columns(4).Title = "DATEI-NAME"
            oCustomTable.Columns(5).Title = "TEIL-TYP"
            oCustomTable.Columns(6).Title = "SPEZIFIKATIONEN"
            oCustomTable.Columns(7).Title = "SEITE"
            
            oCustomTable.Columns(8).Width = 0
            
next_table2:
        Next oCustomTable
    Next SHX
    
    
    For Each SHX In oDrawDoc.Sheets
        For Each oCustomTable In SHX.CustomTables
        
'            If oCustomTable.Title = "PART LIST" Then
'                oCustomTable.Title = "PARTS LIST"
'            End If
    
            If UCase(oCustomTable.Title) <> "TECHNICAL NOTES" Then GoTo next_table3
            
'            If oCustomTable.Columns.Count = 7 Then
'                oCustomTable.Columns.Add "MATERIAL"
'            End If

            
            
            oCustomTable.Columns(1).Title = "ANMERKUNGEN"
            oCustomTable.Columns(2).Title = "INHALT"
            
            oCustomTable.ShowTitle = False
            
next_table3:
        Next oCustomTable
    Next SHX

    
End Sub


Function SHEETx(n As Integer) As Sheet
Dim oDrawDoc As DrawingDocument
Dim oSheet As Sheet
Dim FSHEET2 As String


Set oDrawDoc = ThisApplication.ActiveDocument

Set SHEETx = Nothing

For Each oSheet In oDrawDoc.Sheets
    FSHEET2 = FSHEETx(oSheet)
    
    If Val(FSHEET2) = n Then
        Set SHEETx = oSheet
    End If
Next oSheet

End Function

Function FSHEETx(sh As Sheet) As String
FSHEETx = NSH(sh.Name) 'Mid(sh.Name, InStr(1, sh.Name, ":") + 1)
End Function

Sub TITLE_BLOCK()
On Error Resume Next
Dim oSheet As Sheet, oDoc1 As DrawingDocument, tbd As TitleBlockDefinition, EXPR As String  ', oDoc2 As DrawingDocument
Dim TBDS As Collection, DSK As DrawingSketch
Set oDoc1 = ThisDocument

'FTBD = "OHO_title-block2"
'arn = Array("", "", "", "", "", "", "", "", "", "", "")
Dim arn(1 To 11) As String
    arn(1) = " ": arn(2) = " ": arn(3) = " ": arn(4) = " ": arn(5) = " ": arn(6) = " "
    arn(7) = " ": arn(8) = " ": arn(9) = " ": arn(10) = " ": arn(11) = " "


'Call Module2.FIELDS
EXPR = "": CONT = 0
Set TBDS = New Collection
For Each tbd In ThisDocument.TitleBlockDefinitions
CONT = 1 + CONT
TBDS.Add tbd.Name
EXPR = EXPR + Str$(CONT) + " -> " + tbd.Name + vbCrLf
Next tbd

FTBDS = InputBox(EXPR, "SELECT TITLE BLOCK, WRITE A NUMBER FROM THE LIST")

If Val(FTBDS) = 0 Then Exit Sub

FTBD = TBDS(Val(FTBDS))
    Set tbd = oDoc1.TitleBlockDefinitions(FTBD)

BNDSH = False
For Each oSheet In oDoc1.Sheets
'If Not (BNDSH) Then
'oSheet.TitleBlock.Definition.Edit DSK
'oSheet.TitleBlock.Definition.ExitEdit False
'DoEvents
'BNDSH = True
'End If
    
'    oSheet.Activate
    
    bndtbp = False
     If Not oSheet.TitleBlock Is Nothing Then
        FIELDS
        oSheet.TitleBlock.Delete
        DoEvents
        bndtbp = True
    End If
    
    oDoc1.Update2 (True)
    
'    If Not (BNDSH) Then
'    tbd.Edit DSK
'    tbd.ExitEdit False
'    DoEvents
'    BNDSH = True
    
'    oDoc1.Update2 (True)
    
'    End If
    
    
    
    Call oSheet.AddTitleBlock(tbd, kBottomRightPosition, arn)
    
    DoEvents
    
    If Err.Number = -2147467259 Then
    Err.Clear
    tbd.Edit DSK
    tbd.ExitEdit False
    DoEvents
    oDoc1.Update2 (True)
    ElseIf Err.Number <> 0 Then
    GoTo ERRTB
    End If
    
    If bndtbp Then
    SET_FIELDS1_3
    End If
    
Next oSheet

ERRTB:

If Err Then
Err.Raise (Err.Number)
End
End If


End Sub

Sub A_TRANSLATE_PREPARE_DOCUMENT(Optional void As Integer)

Dim sh1 As Sheet, oDoc1 As DrawingDocument, oDoc2 As DrawingDocument, tbd As TitleBlockDefinition

Set oDoc1 = ThisDocument

If InStr(1, oDoc1.File.FullFileName, "OHO-template") > 0 Then
MsgBox "RUN MACRO FROM DRAWING DOCUMENT", , "RUNING FROM TEMPLATE"
Exit Sub
End If

Set sh1 = oDoc1.Sheets(1)

If sh1.Name = "Sheet" Then
sh1.Delete
End If

    For Each oDoc2x In ThisApplication.Documents
    If InStr(1, oDoc2x.File.FullFileName, "OHO-template") > 0 Then
    Set oDoc2 = oDoc2x
    Exit For
    End If
    Next oDoc2x
    

    If oDoc2 Is Nothing Then
    If MsgBox("CONITUE ANYWAY?" & vbCrLf & "MAY HAVE ERRORS", vbYesNo, "FILE OHO-template IS NOT OPEN") <> vbYes Then
    Exit Sub
    End If
    Else
    For Each tbd In oDoc2.TitleBlockDefinitions
    tbd.CopyTo oDoc1
    Next tbd
    TITLE_BLOCK
    If FTBD = "" Then Exit Sub
    End If


'FTBD = ""
'UserForm2.Show




MATERIAL_COLUMN_VIEW

Set XLFS = New Collection
EXPORT_PARTS_LIST
EXPORT_NOTES1
EXPORT_NOTES2

MsgBox "DOCUMENT IS READY, EXCEL FILES HAS BEEN CREATED, NOW YOU CAN PROCEED TO EDIT:" & vbCrLf & vbCrLf & _
                CollectionToString(XLFS, vbCrLf) & vbCrLf & vbCrLf & _
                "IN THE FOLDER: " + mpath
                
                '"- PART NAME IN PARTS LIST" & vbCrLf & _
                "- SPECIFICATIONS IN PARTS LIST" & vbCrLf & _
                "- MATERIALS IN PARTS LIST" & vbCrLf & _
                "- TECHNICAL NOTES" & vbCrLf & _
                "- OTHER ANOTATIONS"
End Sub

Function CollectionToString(C As Collection, Optional Delimiter As String, Optional TrailingDelimiter As Boolean) As String
' Join a collection into a single string
' OPTIONAL: choose delimiter and specify whether to include a trailing delimiter (e.g. "a;b;c" vs "a;b;c;", where ";" is the delimiter)

    ' Transfer collection to array
    CollectionToString = Join(CollectionToArray(C, 0, C.Count + IIf(TrailingDelimiter, 1, 0)), Delimiter) ' See Referenced Gists below

End Function

Function CollectionToArray(C As Collection, Optional StartIdx As Long, Optional Size As Long) As Variant
' Convert a collection into an array

Dim A() As Variant
Dim Ci As Variant   ' Collection element
Dim I As Long
    
    ' Make sure Size is not less than collection size
    If Size < C.Count Then Size = C.Count
    
    ' Transfer collection to array
    ReDim A(StartIdx To StartIdx + Size - 1)
    For Each Ci In C
        A(I) = Ci
        I = I + 1
    Next

    CollectionToArray = A

End Function



Sub C_TRANSLATE_PREPARE_DOCUMENT(Optional void As String)

MATERIAL_COLUMN_VIEW

MsgBox "DOCUMENT IS READY, NOW YOU CAN PROCEED TO TRANSLATE:" & vbCrLf & _
                "- PART NAME IN PARTS LIST" & vbCrLf & _
                "- SPECIFICATIONS IN PARTS LIST" & vbCrLf & _
                "- MATERIALS IN PARTS LIST" & vbCrLf & _
                "- TECHNICAL NOTES" & vbCrLf & _
                "- OTHER ANOTATIONS"
End Sub


Sub B_TRANSLATE_COMPLETE_PROCESS(Optional void As Integer)
Dim NM As String
'On Error GoTo errx

Set oDoc1 = ThisDocument

If InStr(1, oDoc1.File.FullFileName, "OHO-template") > 0 Then
MsgBox "RUN MACRO FROM DRAWING DOCUMENT", , "RUNING FROM TEMPLATE"
Exit Sub
End If


ESP = MsgBox("YES -> SPANISH" & vbCrLf & "NO -> GERMAN", vbYesNo, "TRANSLATE LABELS TO SPANISH?")

If ESP = vbYes Then
NAME_ES = InputBox("PROJECT NAME IN SPANISH")
NM = NAME_ES & ".idw"
ElseIf ESP = vbNo Then
NAME_DE = InputBox("PROJECT NAME IN GERMAN")
NM = NAME_DE & ".idw"
Else
Exit Sub
End If

NM = Replace(NM, Chr(10), "")

IMPORT_PARTS_LIST
IMPORT_NOTES1
IMPORT_NOTES2

PARTLIST_TO_BLOCKS

If ESP = vbYes Then
TRANSLATE_LABELS_ES
ElseIf ESP = vbNo Then
TRANSLATE_LABELS_DE
End If

MATERIAL_COLUMN_HIDE
'ThisDocument.Save ' mpath & NM, True

'Dim oPM As PrintManager
'Set oPM = ThisApplication.ActiveDocument.PrintManger
'
'nm2 = Replace(NM, "idw", "pdf")
'
'oPM.Printer = "PDF24"
'oPM.PrinteToFile nm2

errx:
If Err Then
MsgBox "COMPLETE FAILED, DELETE PREVIOUS FILE NAMES AS: " & NM '& " / pdf"
Else
MsgBox "PROCESS COMPLETED, PRINTING AS PDF AND COPY SAVING" ' AS: " & NM ' & " / pdf"
plotx
SAVECOPYx
'If MsgBox("REPEAT TRANSLATION?", vbYesNo) = vbYes Then
'
'C_TRANSLATE_PREPARE_DOCUMENT
'
'End If
End If

End Sub

Sub plotx(Optional void As Integer)
SendKeys "%F"
SendKeys "P"
End Sub

Sub SAVECOPYx(Optional void As Integer)
SendKeys "%F"
SendKeys "F"
SendKeys "C"
End Sub

Function mpath() As String
    Dim oDoc As Document
    Set oDoc = ThisDocument
    ffn = oDoc.File.FullFileName
    mpath = Left(ffn, InStrRev(ffn, "\"))
End Function

Function PTH_FNM(P As String, SBS As String) As String
    PTH_FNM = Right(P, Len(P) - InStrRev(P, SBS))
End Function





Sub EXPORT_PARTS_LIST()
Dim oDoc As DrawingDocument, oSheet As Sheet, oTable As CustomTable, NMPL As String
SPL = MsgBox("IS YOUR PARTS LIST AN INVENTOR SPLITTED TABLE?", vbYesNo)
If (SPL <> vbYes) And (SPL <> vbNo) Then Exit Sub
Set oDoc = ThisDocument
SHX = 0
For Each oSheet In oDoc.Sheets
SHX = 1 + SHX
TBX = 0
For Each oTable In oSheet.CustomTables
TBX = 1 + TBX
If UCase(oTable.Title) = "PART LIST" Then
oTable.Title = "PARTS LIST"
End If
If oTable.Rows.Count = 0 Then GoTo continue
If UCase(oTable.Title) = "PARTS LIST" Then
NMPL = mpath + "macro-parts-list_page" + Str$(SHX) + "_table" + Str$(TBX) + ".xlsx"
oTable.Export NMPL, kMicrosoftExcelFormat
If Not (XLFS Is Nothing) Then
XLFS.Add PTH_FNM(NMPL, "\")
End If
If (SPL = vbYes) Then Exit Sub
End If
continue:
Next
Next
End Sub

Sub EXPORT_NOTES1()
Dim oDoc As DrawingDocument, oSheet As Sheet, oTable As CustomTable, oNote As DrawingNote, ORW As Row, p2d As Point2d, NMPL As String
Set oDoc = ThisDocument
SHX = 0

    Dim oTitles(1 To 3) As String
    oTitles(1) = "SHEET"
    oTitles(2) = "NOTE"
    oTitles(3) = "CONTENT"
    
For Each oTable In oDoc.Sheets(1).CustomTables
If oTable.Title = "NOTES1" Then
oTable.Delete
End If
Next oTable
Set p2d = ThisApplication.TransientGeometry.CreatePoint2d(500, 500)
    Set oTable = oDoc.Sheets(1).CustomTables.Add("NOTES1", p2d, _
                                          3, 0, oTitles)
                                          
For Each ORW In oTable.Rows
ORW.Delete
Next ORW

For Each oSheet In oDoc.Sheets
SHX = 1 + SHX
ntx = 0
For Each oNote In oSheet.DrawingNotes
ntx = 1 + ntx
ntxc = Trim(oNote.Text)
If ntxc <> "" Then
Set ORW = oTable.Rows.Add
ORW.Item(1).Value = SHX
ORW.Item(2).Value = ntx
ORW.Item(3).Value = ntxc
End If
Next oNote
Next oSheet

If oTable.Rows.Count > 0 Then
NMPL = mpath + "macro-notes1" + ".xlsx"
oTable.Export NMPL, kMicrosoftExcelFormat
If Not (XLFS Is Nothing) Then
XLFS.Add PTH_FNM(NMPL, "\")
End If
End If

oTable.Delete

End Sub

Sub EXPORT_NOTES2()
Dim oDoc As DrawingDocument, oSheet As Sheet, oTable As CustomTable, NMPL As String
'Dim oOptions As NameValueMap

'Set oOptions = ThisApplication.TransientObjects.CreateNameValueMap
'oOptions.Value("ExportedColumns") = "ITEM;Total QTY;DESCRIPTION;# OF TAGS;PART No."
'oOptions.Value("StartingCell") = "A1"
'oOptions.Value("TableName") = ThisDoc.FileName(False) 'without extension
'oOptions.Value("IncludeTitle") = True
'oOptions.Value("AutoFitColumnWidth") = True

Set oDoc = ThisDocument
SHX = 0
For Each oSheet In oDoc.Sheets
SHX = 1 + SHX
TBX = 0
For Each oTable In oSheet.CustomTables
TBX = 1 + TBX
If UCase(oTable.Title) = "TECHNICL NOTES" Then
oTable.Title = "TECHNICAL NOTES"
End If
If oTable.Rows.Count = 0 Then GoTo continue
If UCase(oTable.Title) = "TECHNICAL NOTES" Then
NMPL = mpath + "macro-tech-notes_page" + Str$(SHX) + "_table" + Str$(TBX) + ".xlsx"
oTable.Export NMPL, kMicrosoftExcelFormat ', oOptions
If Not (XLFS Is Nothing) Then
XLFS.Add PTH_FNM(NMPL, "\")
End If
End If
continue:
Next
Next
End Sub


Sub IMPORT_PARTS_LIST()
Dim oDoc As DrawingDocument, oSheet As Sheet, oTable As CustomTable, oTable2 As CustomTable, p2d As Point2d, orw1 As Row, orw2 As Row, colx As Column
SPL = MsgBox("IS YOUR PARTS LIST AN INVENTOR SPLITTED TABLE?", vbYesNo)
If (SPL <> vbYes) And (SPL <> vbNo) Then Exit Sub
Set oDoc = ThisDocument
SHX = 0
For Each oSheet In oDoc.Sheets

For Each oTable In oSheet.CustomTables
If oTable.Title = "PLE" Then
oTable.Delete
End If
Next oTable


SHX = 1 + SHX
TBX = 0
For Each oTable In oSheet.CustomTables
TBX = 1 + TBX
If UCase(oTable.Title) = "PART LIST" Then
oTable.Title = "PARTS LIST"
End If
If oTable.Rows.Count = 0 Then GoTo continue
If UCase(oTable.Title) = "PARTS LIST" Then
NMPL = mpath + "macro-parts-list_page" + Str$(SHX) + "_table" + Str$(TBX) + ".xlsx"
Set p2d = ThisApplication.TransientGeometry.CreatePoint2d(500, 1000)
Set oTable2 = oSheet.CustomTables.AddExcelTable(NMPL, p2d, "PLE")
J = 0
t2r = oTable2.Rows.Count
t2c = oTable2.Columns.Count
For J = 1 To t2r
Set orw1 = oTable.Rows(J)
'For Each orw1 In oTable2.Rows
'j = 1 + j
Set orw2 = oTable2.Rows(J)
I = 0
For I = 1 To t2c
''For Each colx In oTable2.Columns
''i = 1 + i
orw1.Item(I).Value = orw2.Item(I).Value
'Next colx
'Next orw1
Next I
Next J
oTable2.Delete
If (SPL = vbYes) Then Exit Sub
End If
continue:
Next oTable
Next oSheet

End Sub

Sub IMPORT_NOTES2()
Dim oDoc As DrawingDocument, oSheet As Sheet, oTable As CustomTable, oTable2 As CustomTable, p2d As Point2d, orw1 As Row, orw2 As Row, colx As Column
Set oDoc = ThisDocument
SHX = 0
For Each oSheet In oDoc.Sheets


For Each oTable In oDoc.Sheets(1).CustomTables
If oTable.Title = "N2E" Then
oTable.Delete
End If
Next oTable



SHX = 1 + SHX
TBX = 0

For Each oTable In oSheet.CustomTables
TBX = 1 + TBX

If UCase(oTable.Title) = "TECHNICL NOTES" Then
oTable.Title = "TECHNICAL NOTES"
End If
If oTable.Rows.Count = 0 Then GoTo continue
If UCase(oTable.Title) = "TECHNICAL NOTES" Then
NMPL = mpath + "macro-tech-notes_page" + Str$(SHX) + "_table" + Str$(TBX) + ".xlsx"
Set p2d = ThisApplication.TransientGeometry.CreatePoint2d(500, 1000)
Set oTable2 = oSheet.CustomTables.AddExcelTable(NMPL, p2d, "N2E")
J = 0
t2r = oTable2.Rows.Count
t2c = oTable2.Columns.Count
For J = 1 To t2r
Set orw1 = oTable.Rows(J)
'For Each orw1 In oTable2.Rows
'j = 1 + j
Set orw2 = oTable2.Rows(J)
I = 0
For I = 1 To t2c
''For Each colx In oTable2.Columns
''i = 1 + i
orw1.Item(I).Value = orw2.Item(I).Value
'Next colx
'Next orw1
Next I
Next J
oTable2.Delete
End If
continue:
Next oTable
Next oSheet

End Sub


Sub IMPORT_NOTES1()
Dim oDoc As DrawingDocument, oSheet As Sheet, oTable2 As CustomTable, oNote As DrawingNote, ORW As Row, p2d As Point2d
Dim oSheetx As Sheet, SHX As Integer, ntx As Integer, ntxc As String, bndn As Boolean
Set oDoc = ThisDocument
                                        
Set oSheet = oDoc.Sheets(1)

For Each oTable In oSheet.CustomTables
If oTable.Title = "NOTES1" Then
oTable.Delete
End If
Next oTable

bndn = False
For Each oSheet In oDoc.Sheets
SHX = 1 + SHX
ntx = 0
For Each oNote In oSheet.DrawingNotes
ntx = 1 + ntx
ntxc = Trim(oNote.Text)
If ntxc <> "" Then
bndn = True
GoTo exf
End If
Next oNote
Next oSheet

exf:

If Not (bndn) Then Exit Sub

ntx = 0
NMPL = mpath + "macro-notes1.xlsx"
Set p2d = ThisApplication.TransientGeometry.CreatePoint2d(500, 1000)
Set oTable2 = oSheet.CustomTables.AddExcelTable(NMPL, p2d, "NOTES1")
For Each ORW In oTable2.Rows
SHX = CInt(Val(ORW.Item(1).Value))
ntx = CInt(Val(ORW.Item(2).Value))
ntxc = ORW.Item(3).Value
Set oSheetx = oDoc.Sheets(SHX)
Set oNote = oSheetx.DrawingNotes(ntx)
oNote.Text = ntxc

'oSheetx.Activate
'oDoc.Update
Next ORW

oTable2.Delete

End Sub



Public Sub CreateFileDialog(Optional void As Integer)

  ' create the file dialog

  Dim oDLG As FileDialog

Set oDLG = Nothing
  ThisApplication.CreateFileDialog oDLG

 

  ' configure

  oDLG.FILENAME = "C:\Temp\Temp.ipt"

  oDLG.Filter = "Inventor Part Files (*.ipt)|*.ipt"

'  oDLG.ShowSave ' to save files

  MsgBox oDLG.ShowOpen ' to open files

End Sub

Function GetFilex(Optional df As String = "Inventor Drawing Files (*.idw)|*.idw") As String
    ' Create a new FileDialog object.
    Dim oFileDlg As FileDialog
    Call ThisApplication.CreateFileDialog(oFileDlg)

    oFileDlg.Filter = df

'    oFileDlg.FilterIndex = 1

    ' Set the title for the dialog.
    oFileDlg.DialogTitle = "Open File"

    ' Set the initial directory that will be displayed in the dialog.
    oFileDlg.InitialDirectory = mpath ' "C:\Temp"

    ' Set the flag so an error will be raised if the user clicks the Cancel button.
    oFileDlg.CancelError = True

    ' Show the open dialog.  The same procedure is also used for the Save dialog.
    ' The commented code can be used for the Save dialog.
    On Error Resume Next
    oFileDlg.ShowOpen
'    oFileDlg.ShowSave

    ' If an error was raised, the user clicked cancel, otherwise display the filename.
    If Err Then
'        MsgBox "User cancelled out of dialog"
    ElseIf oFileDlg.FILENAME <> "" Then
'        MsgBox "File " & oFileDlg.FileName & " was selected."
        GetFilex = oFileDlg.FILENAME
    End If
End Function

Sub GET_SHEETS()
Dim oDoc1 As DrawingDocument, oDoc2 As DrawingDocument, oSheet1 As Sheet, oSheet2 As Sheet, oTb As TitleBlock

FN = GetFilex
If FN = "" Then Exit Sub

Set oDoc1 = ThisDocument
Set oDoc2 = ThisApplication.Documents.Open(FN, False)


For Each oSheet2 In oDoc2.Sheets
oSheet2.TitleBlock.Delete
Next oSheet2

For Each oSheet2 In oDoc2.Sheets
Set oSheet1 = oSheet2.CopyTo(oDoc1)

Next oSheet2


oDoc2.Close True

End Sub

Sub DUPLICATE_SHEET()

Dim oDoc As DrawingDocument
Set oDoc = ThisApplication.ActiveDocument

Dim tmpDoc As DrawingDocument
Set tmpDoc = ThisApplication.Documents.Add(kDrawingDocumentObject, , True)


Dim newSheet As Sheet
Set newSheet = oDoc.ActiveSheet.CopyTo(tmpDoc)

Call newSheet.CopyTo(oDoc)

tmpDoc.Close (True)

End Sub

'Function Map(F As String, ByVal A As Variant) As Variant
'' Map function F across 1-Dimensional Array
'
'Dim i As Long
'
'    For i = LBound(A) To UBound(A)
'        A(i) = Application.Run(F, A(i))
'    Next i
'
'    Map = A
'
'End Function

Sub ZERO_SUPRESS(Optional void As Integer)
Dim oDoc As DrawingDocument, oSheet As Sheet, oTable As CustomTable, oRow As Row
Dim itms As New Collection, ITMS2 As Collection, DRT As Boolean
Set oDoc = ThisDocument

For Each oSheet In oDoc.Sheets
For Each oTable In oSheet.CustomTables
If UCase(oTable.Title) <> "PARTS LIST" Then GoTo next_table
For Each oRow In oTable.Rows
POS = oRow.Item(1).Value
If Val(POS) > 0 Then
itms.Add POS
End If
Next oRow
next_table:
Next oTable
Next oSheet

If itms.Count = 0 Then Exit Sub

DRT = False
REVZ:

TL = 0
For Each POS In itms
POS_ARR = Split(POS, ".")
POS_TLX = Val(POS_ARR(UBound(POS_ARR)))
TL = TL + POS_TLX
Next POS

If TL > 0 Then GoTo SET_POS

Set ITMS2 = New Collection
For Each POS In itms
POSX = Left(POS, InStrRev(POS, ".") - 1)
ITMS2.Add POSX
Next POS

DRT = True
Set itms = ITMS2

GoTo REVZ

SET_POS:

If Not (DRT) Then Exit Sub

I = 0
For Each oSheet In oDoc.Sheets
For Each oTable In oSheet.CustomTables
If UCase(oTable.Title) <> "PARTS LIST" Then GoTo next_table2
For Each oRow In oTable.Rows
POS = oRow.Item(1).Value
If Val(POS) > 0 Then
I = 1 + I
oRow.Item(1).Value = itms(I)
End If
Next oRow
next_table2:
Next oTable
Next oSheet

End Sub


Sub ZERO_SUPRESS2(Optional void As Integer)
Dim oDoc As DrawingDocument, oSheet As Sheet, oTb As TitleBlock
Dim itms As New Collection, ITMS2 As Collection, DRT As Boolean
Set oDoc = ThisDocument

For Each oSheet In oDoc.Sheets
Set oTb = oSheet.TitleBlock
Set textB = oTb.Definition.Sketch.TextBoxes(9)
POS = oTb.GetResultText(textB)
If Val(POS) > 0 Then
itms.Add POS
End If
Next oSheet

If itms.Count = 0 Then Exit Sub

DRT = False
REVZ:

TL = 0
For Each POS In itms
POS_ARR = Split(POS, ".")
POS_TLX = Val(POS_ARR(UBound(POS_ARR)))
TL = TL + POS_TLX
Next POS

If TL > 0 Then GoTo SET_POS

Set ITMS2 = New Collection
For Each POS In itms
POSX = Left(POS, InStrRev(POS, ".") - 1)
ITMS2.Add POSX
Next POS

DRT = True
Set itms = ITMS2

GoTo REVZ

SET_POS:

If Not (DRT) Then Exit Sub

I = 0
For Each oSheet In oDoc.Sheets
Set oTb = oSheet.TitleBlock
Set textB = oTb.Definition.Sketch.TextBoxes(9)
POS = oTb.GetResultText(textB)
If Val(POS) > 0 Then
I = 1 + I
oTb.SetPromptResultText textB, itms(I)
oSheet.Name = IIf(itms(I) = "", oSheet.Name, itms(I))
End If
Next oSheet

End Sub


Sub ZERO_ADD(Optional void As Integer)
Dim oDoc As DrawingDocument, oSheet As Sheet, oTable As CustomTable, oRow As Row
Dim L As Integer

Set oDoc = ThisDocument
'Debug.Print Len("1.2.3") - Len(Replace("1.2.3", ".", ""))
'MsgBox "count = " & UBound(Split(S, "A"))
L = 0
For Each oSheet In oDoc.Sheets
For Each oTable In oSheet.CustomTables
If UCase(oTable.Title) <> "PARTS LIST" Then GoTo next_table
For Each oRow In oTable.Rows
POS = oRow.Item(1).Value
If Val(POS) > 0 Then
Lx = Len(POS) - Len(Replace(POS, ".", ""))
L = IIf(Lx > L, Lx, L)
End If
Next oRow
next_table:
Next oTable
Next oSheet


For Each oSheet In oDoc.Sheets
For Each oTable In oSheet.CustomTables
If UCase(oTable.Title) <> "PARTS LIST" Then GoTo next_table2
For Each oRow In oTable.Rows
POS = oRow.Item(1).Value
If Val(POS) > 0 Then
Lx = Len(POS) - Len(Replace(POS, ".", ""))
If L > Lx Then
d = L - Lx
For I = 1 To d
POS = POS + ".0"
Next I
oRow.Item(1).Value = POS
End If
End If
Next oRow
next_table2:
Next oTable
Next oSheet

End Sub


Sub ZERO_ADD2(Optional void As Integer)
Dim oDoc As DrawingDocument, oSheet As Sheet, oTable As CustomTable, oRow As Row
Dim L As Integer

Set oDoc = ThisDocument
'Debug.Print Len("1.2.3") - Len(Replace("1.2.3", ".", ""))
'MsgBox "count = " & UBound(Split(S, "A"))
L = 0
For Each oSheet In oDoc.Sheets
Set oTb = oSheet.TitleBlock
Set textB = oTb.Definition.Sketch.TextBoxes(9)
POS = oTb.GetResultText(textB)
If Val(POS) > 0 Then
Lx = Len(POS) - Len(Replace(POS, ".", ""))
L = IIf(Lx > L, Lx, L)
End If
Next oSheet


For Each oSheet In oDoc.Sheets
Set oTb = oSheet.TitleBlock
Set textB = oTb.Definition.Sketch.TextBoxes(9)
POS = oTb.GetResultText(textB)
If Val(POS) > 0 Then
Lx = Len(POS) - Len(Replace(POS, ".", ""))
If L > Lx Then
d = L - Lx
For I = 1 To d
POS = POS + ".0"
Next I
oTb.SetPromptResultText textB, POS
oSheet.Name = IIf(POS = "", oSheet.Name, POS)
End If
End If
Next oSheet

End Sub

Sub ZERO_CHECK()
ZERO_ADD
ZERO_SUPRESS
End Sub

Sub ZERO_CHECK2()
ZERO_ADD2
ZERO_SUPRESS2
End Sub


Sub TITLE_BLOCK2(tbd As TitleBlockDefinition, oSheet As Sheet)
On Error Resume Next
Dim oDoc1 As DrawingDocument, EXPR As String  ', oDoc2 As DrawingDocument
Dim TBDS As Collection, DSK As DrawingSketch
Set oDoc1 = ThisDocument

'FTBD = "OHO_title-block2"
'arn = Array("", "", "", "", "", "", "", "", "", "", "")
Dim arn(1 To 11) As String
    arn(1) = " ": arn(2) = " ": arn(3) = " ": arn(4) = " ": arn(5) = " ": arn(6) = " "
    arn(7) = " ": arn(8) = " ": arn(9) = " ": arn(10) = " ": arn(11) = " "
    
    Call oSheet.AddTitleBlock(tbd, kBottomRightPosition, arn)
    
    DoEvents
    
    If Err.Number = -2147467259 Then
    Err.Clear
    tbd.Edit DSK
    tbd.ExitEdit False
    DoEvents
    oDoc1.Update2 (True)
    ElseIf Err.Number <> 0 Then
    GoTo ERRTB2
    End If


ERRTB2:

If Err Then
Err.Raise (Err.Number)
End
End If


End Sub


Sub Sort(ByVal C As Collection)
Dim I As Long, J As Long
For I = 1 To C.Count - 1
    For J = I + 1 To C.Count
        If C(I)(0) > C(J)(0) Then Swap C, I, J
    Next
Next
End Sub

'Take good care that J > I
Sub Swap(ByVal C As Collection, ByVal I As Long, ByVal J As Long)
C.Add C(J), , , I
C.Add C(I), , , J + 1
C.Remove I
C.Remove J
End Sub


Sub CreateDrawingComponents()
Dim oDrawDoc As DrawingDocument
Dim oSheet As Sheet, oSheetx As Sheet, oBaloom As Balloon
Dim oDoc As Document, tbd As TitleBlockDefinition, bdd As BorderDefinition, bc As Collection
Dim tbd2 As TitleBlockDefinition, tb2 As TitleBlock

Dim sheetNode As BrowserNode, bottomNode As BrowserNode, BrowserPane, nodex As BrowserNode
Dim nodexx As BrowserNode


Set oDrawDoc = ThisApplication.ActiveDocument
Set BrowserPane = oDrawDoc.BrowserPanes.Item("Model")
Set oSheet = oDrawDoc.ActiveSheet

'MsgBox BrowserPane.TopNode.BrowserNodes(1).FullPath
'Set sheetNode = BrowserPane.TopNode.BrowserNodes(11)

'Set sheetNode = BrowserPane.GetBrowserNodeFromObject(oSheet)
Set sheetNode = BrowserPane.TopNode.BrowserNodes.Item(BrowserPane.TopNode.BrowserNodes.Count)
For Each nodexx In BrowserPane.TopNode.BrowserNodes
If InStr(1, nodexx.BrowserNodeDefinition.Label, oSheet.Name) > 0 Then
Set sheetNode = nodexx
Exit For
End If
Next nodexx



Set tbd = oSheet.TitleBlock.Definition
Set bdd = oSheet.Border.Definition
sz = oSheet.Size
Dim oPoint1 As Point2d
shh = oSheet.height / 2
shw = oSheet.Width / 2
Set oPoint1 = ThisApplication.TransientGeometry.CreatePoint2d(shw, shh)
Set nodex = Nothing

Set bc = New Collection
For Each oBaloom In oSheet.Balloons
FPOSX = Trim(oBaloom.BalloonValueSets(1).OverrideValue)
FPOSX = IIf(FPOSX = "", oBaloom.BalloonValueSets(1).Value, FPOSX)
bc.Add Array(FPOSX, oBaloom), FPOSX
Next oBaloom

Call Sort(bc)

For Each elementx In bc
    Set oBaloom = elementx(1)
    Set oDoc = oBaloom.BalloonValueSets(1).ReferencedFiles(1).ReferencedDocument
    Debug.Print oDoc.DisplayName
    Set oSheetx = oDrawDoc.Sheets.Add
    Set bottomNode = BrowserPane.TopNode.BrowserNodes.Item(BrowserPane.TopNode.BrowserNodes.Count)
    If nodex Is Nothing Then
        Set nodex = sheetNode
    End If
    BrowserPane.Reorder nodex, False, bottomNode
    Set nodex = bottomNode
    FPOS = Trim(oBaloom.BalloonValueSets(1).OverrideValue)
    FPOS = IIf(FPOS = "", oBaloom.BalloonValueSets(1).Value, FPOS)
    oSheetx.Size = sz
    oSheetx.AddBorder bdd
    TITLE_BLOCK2 tbd, oSheetx
    oSheetx.DrawingViews.AddBaseView oDoc, oPoint1, 1, kIsoTopLeftViewOrientation, kHiddenLineRemovedDrawingViewStyle
    Set tb2 = oSheetx.TitleBlock
    Set tbd2 = tb2.Definition
    Set textB = tbd2.Sketch.TextBoxes(9)
    tb2.SetPromptResultText textB, FPOS
    oSheetx.Name = IIf(FPOS = "", oSheetx.Name, FPOS)
Next elementx


End Sub

